import greenfoot.*;

/**
 * Write a description of class Bosque here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bosque extends World
{
    public 
    Scroll scroll;
    niño kid; 
    Duende d;
    public Bosque()
    {
        super(800, 600, 1, false);
        GreenfootImage bgImage = getScrollBg();
        scroll  = new Scroll(bgImage, this);
        crearArboles();
        crearArbustos();
        crearRocas();
        kid=new niño();
        addObject(kid,-100,201);
        d=new Duende();
        addObject(d,-250,201);
        addObject(new Piso(),15000,500);
        crearTroncos();
        addObject(new casa(),29824,372);
    }
    public void crearRocas(){
        for(int i=1150;i<30000;i=i+900){
            addObject(new roca(),i,482);
        }
    }
    public void crearTroncos(){
        for(int i=700;i<30000;i=i+900){
            addObject(new tronco(),i,480);
        }
    }
    public void crearArboles(){
        for(int i=600;i<30000;i=i+600){
            addObject(new Arbol(),i,321);
        }
    }
    public void crearArbustos(){
        for(int i=73;i<=30000;i=i+160){
            addObject(new Arbusto(),i,454);
        }
    }
    public void act()
    {
        scroll();
        if(kid.getVel()==0){
            d.setVel(0);
        }
    }

    private GreenfootImage getScrollBg()
    {
        GreenfootImage bg = new GreenfootImage(30000, 600);
        bg.setColor(java.awt.Color.black);
        bg.fill();
        bg.setColor(new java.awt.Color(200, 100, 100));
        int h = 500;
        for (int x=0; x<bg.getWidth(); x+=5)
        {
            int chg = 0;
            while (h+chg >= getHeight()) chg--;
            for (int n=0; n<5; n++) bg.drawLine(x+n, h+(chg*n/5), x+n, bg.getHeight());
            h += chg;
        }
        return bg;
    }

    public void scroll()
    {
        int limitX = 600;
        int ds = kid.getX();
        if (ds >= limitX && ds <= getWidth()-limitX) return;
        if (ds > getWidth()-limitX) ds -= getWidth()-limitX*2;
        ds -= limitX; 
        int scrolledAmt = scroll.changeScrollX(ds);
        for (Object obj : getObjects(null))
        {
            Actor actor = (Actor)obj;
            actor.setLocation(actor.getX()-scrolledAmt, actor.getY());
        }
    }
}