import greenfoot.World;
import greenfoot.GreenfootImage;

/**
 * Escribe una descrición de la clase Scroll aquí.
 * 
 * @autor (tu nombre) 
 * @versión (Un número de versión o una fecha)
 */
public class Scroll
{
    private int offX, offY;
    private World w;
    private GreenfootImage bg;
    
    public Scroll(GreenfootImage bgImg, World world)
    {
        bg = bgImg;
        w = world;
        changeScroll(0, 0);
    }
    
    public int changeScrollX(int dScroll)
    {
        if (offX+dScroll >  bg.getWidth()-w.getWidth()) dScroll = bg.getWidth()-w.getWidth()-offX;
        if (offX+dScroll < 0) dScroll = -offX;
        offX += dScroll;
        w.getBackground().drawImage(bg, -offX, 0);
        return dScroll;
    }
    
    public int changeScrollY(int dScroll)
    {
        if (offY+dScroll > bg.getHeight()-w.getHeight()) dScroll = bg.getHeight()-w.getHeight()-offY;
        if (offY+dScroll < 0) dScroll = -offY;
        offY += dScroll;
        w.getBackground().drawImage(bg, 0, -offY);
        return dScroll;
    }
    
    public int[] changeScroll(int dScrollX, int dScrollY)
    {
        int[] scrolled = new int[2];
        if (offX+dScrollX > bg.getWidth()-w.getWidth()) dScrollX = bg.getWidth()-w.getWidth()-offX;
        if (offY+dScrollY > bg.getHeight()-w.getHeight()) dScrollY = bg.getHeight()-w.getHeight()-offY;
        if (offX+dScrollX < 0) dScrollX = -offX;
        if (offY+dScrollY < 0) dScrollY = -offY;
        offX += dScrollX;
        offY += dScrollY;
        w.getBackground().drawImage(bg, -offX, -offY);
        scrolled[0] = dScrollX;
        scrolled[1] = dScrollY;
        return scrolled;
    }
}